#include <QLineEdit>
#include <QVBoxLayout>
#include <QLabel>

#include "findwidget.h"


extern QString vymName;

FindWidget::FindWidget(QWidget *)
{
    QVBoxLayout* mainLayout = new QVBoxLayout;
    QHBoxLayout *row2Layout = new QHBoxLayout;
    
	// Create Buttons
	cancelbutton = new QPushButton;
	cancelbutton->setText(tr("Cancel"));
	cancelbutton->setShortcut (Qt::Key_Escape);
	connect ( cancelbutton, SIGNAL( clicked() ), this, SLOT( cancelPressed() ) );
	
	QLabel *label=new QLabel;
	label->setText (tr("Find:","FindWidget"));
	
	// Create LineEdit (here QComboBox)
    findcombo = new QComboBox;
	findcombo->setMinimumWidth(250);
	findcombo->setEditable(true);
	connect ( findcombo, SIGNAL( highlighted(int) ), 
		this, SLOT( nextPressed() ) );
	connect ( findcombo, SIGNAL( textChanged(const QString &) ), 
		this, SLOT( findTextChanged(const QString&) ) );

	nextbutton = new QPushButton;
	nextbutton->setText (tr("Next","Find widget"));
	nextbutton->setDefault (true);
	nextbutton->setShortcut (Qt::Key_Return);
	//nextbutton->setShortcutContext (Qt::WidgetShortcut);
	connect ( nextbutton, SIGNAL( clicked() ), this, SLOT( nextPressed() ) );

	row2Layout->addWidget (cancelbutton);
	row2Layout->addWidget (label);
	row2Layout->addWidget(findcombo);
	row2Layout->addWidget(nextbutton);

	mainLayout->addLayout (row2Layout);

	setLayout (mainLayout);
	setStatus (Undefined);
}

void FindWidget::popup()
{
	show();
	findcombo->lineEdit()->selectAll();
	findcombo->setFocus();
}

void FindWidget::cancelPressed()
{
	hide();
}

void FindWidget::nextPressed()
{
	emit (nextButton(findcombo->currentText() ) );
}

void FindWidget::findTextChanged(const QString&)
{
	emit (somethingChanged() );
}

void FindWidget::setStatus (Status st)
{
	QPalette p=palette();
	QColor c;
	switch (st)
	{
		case Success: c=QColor (100,255,100); break;
		case Failed:  c=QColor (255,100,100); break;
		default:  c=QColor (255,255,255); 
	}
    p.setColor(QPalette::Active, static_cast<QPalette::ColorRole>(9), c);
    p.setColor(QPalette::Inactive, static_cast<QPalette::ColorRole>(9), c);
    findcombo->setPalette(p);
}

